#ifndef GBACKGROUND_H
  #include "gBackGround.h"
#endif

gint userealmime, first = 1, movemode;
gfloat speed, radius;
guint timeout = 0, timeout2 = 0;
gint storethumbs;

void init(void)
{
  gchar **dirname, **fnames;
  gint x;

  srand((unsigned int)time(NULL));
  gnome_config_get_vector(
    "/gBackGround_applet/Look_For/Directories=~/.enlightenment/backgrounds",
     &dirnum, &dirname);
  gnome_config_get_vector(
    "/gBackGround_applet/Look_For/Files=", &filesnum, &fnames);
  curfile = lastfile = gnome_config_get_string(
    "gBackGround_applet/Look_For/Current_File=");
  startmode = gnome_config_get_int( "/gBackGround_applet/Mode/Start_Mode=0");
  changemode = gnome_config_get_int( "/gBackGround_applet/Mode/Change_Mode=0");
  interval = gnome_config_get_int( "/gBackGround_applet/Misc/Interval=300");
  tile = gnome_config_get_int( "/gBackGround_applet/Mode/Tiled=1");
  scaleit = gnome_config_get_int( "/gBackGround_applet/Mode/Scaled=0");
  center = gnome_config_get_int( "/gBackGround_applet/Mode/Centered=0");
  movemode = gnome_config_get_int( "/gBackGround_applet/Mode/movemode=0");
  speed = gnome_config_get_float( "/gBackGround_applet/Misc/speed=2");
  radius = gnome_config_get_float( "/gBackGround_applet/Misc/radius=100");
  storethumbs = gnome_config_get_float( "/gBackGround_applet/Misc/storethumbs=0");
  userealmime = gnome_config_get_int(
    "/gBackGround_applet/Misc/Use_Real_Mime=0");
  interval *= 1000;
  dirlist = makedlist(dirlist, dirname, dirnum);
  indfiles = makeflist(indfiles, fnames, filesnum);
  if (first) {
    if (startmode == 1) button1_callback(NULL, NULL);
    else if (startmode == 2 && curfile && strcmp(curfile, ""))
      draw_background(curfile);
  }
  else draw_background(curfile);
  if (changemode == 1)
    timeout = gtk_timeout_add(interval, (GtkFunction)changebgrandom, NULL);
  if (changemode == 2) timeout = gtk_timeout_add(interval,
                                       (GtkFunction)changebglinear,
                                        NULL);
  if (movemode == 1)
    timeout2 = gtk_timeout_add(speed, (GtkFunction)movebg, NULL);
  first = 0;
  for (x = 0; x < filesnum; x++) g_free(fnames[x]);
  for (x = 0; x < dirnum; x++) g_free(dirname[x]);
  g_free(fnames);
  g_free(dirname);
}

GList *makedlist(GList *root, gchar **names, gint num)
{
  gint x;
  DIR *dir;
  struct dirent *dent;
  gchar *filename, *homedirname, *curdirname;
  const gchar *mime;
  GList *cur = NULL;
  struct entry *curentry;

  homedirname = g_get_home_dir();
  for (x = 0; x < num; x++) {
    cur = NULL;
    if (names[x][0] == '~') {
      curdirname = (char *)g_malloc(sizeof(char)*(strlen(homedirname) +
                                   strlen(names[x])));
      strcpy(curdirname, homedirname);
      strcat(curdirname, &(names[x][1]));
    }
    else {
      curdirname = (char *)g_malloc(sizeof(char)*(strlen(names[x]) + 1));
      strcpy(curdirname, names[x]);
    }
    if ((dir = opendir(curdirname)) == NULL) {
      fprintf(stderr, "%s:", curdirname);  fflush(stderr);
      perror("Could not open directory!!");
      g_free(curdirname);
      continue;
    }
    dirnames = g_list_append(dirnames, curdirname);
    while ((dent = readdir(dir)) != NULL) {
      filename = (char *)g_malloc(sizeof(char) * (strlen(curdirname) +
                                  strlen(dent->d_name) + 2));
      strcpy(filename, curdirname);
      if (filename[strlen(filename)] != '/') strcat(filename, "/");
      strcat(filename, dent->d_name);
      if (((userealmime && (mime = gnome_mime_type_of_file(filename))) ||
            (mime = gnome_mime_type(filename))) &&
            !g_strncasecmp("image", mime, 5)) {
         curentry = (struct entry*)g_malloc(sizeof(struct entry));
         curentry->path = strdup(filename);
         curentry->thumb = NULL;
        cur = g_list_append(cur, curentry);
        g_free(filename);
      }
    }
    filelist = g_list_concat(filelist, g_list_copy(cur));
    root = g_list_append(root, cur);
    closedir(dir);
  }
  dirnames = g_list_prepend(dirnames, "(Indavidual Files.)");
  return root;
}

GList *makeflist(GList *root, gchar **names, gint num)
{
  gint x;
  gchar *filename, *homedirname;
  const gchar *mime;
  struct stat statbuf;
  struct entry *curentry;

  for (x = 0; x < num; x++) {
    if (names[x][0] == '~') {
      homedirname = g_get_home_dir();
      filename = (char *)g_malloc(sizeof(char)*(strlen(homedirname) +
                                   strlen(names[x])));
      strcpy(filename, homedirname);
      strcat(filename, &(names[x][1]));
    }
    else {
      filename = (char *)g_malloc(sizeof(char)*(strlen(names[x]) + 1));
      strcpy(filename, names[x]);
    }
    if (stat(filename, &statbuf) == -1) {
      fprintf(stderr, "%s:", filename);
      perror("Could not get stats on file!!!");
      continue;
    }
    if (S_ISREG(statbuf.st_mode) && (mime =
        gnome_mime_type_of_file(filename)) &&
        !g_strncasecmp("image", mime, 5)) {
      curentry = (struct entry*)g_malloc(sizeof(struct entry));
      curentry->path = strdup(filename);
      curentry->thumb = NULL;
      root = g_list_append(root, curentry);
      g_free(filename);
    }
  }
  /*root = g_list_sort(root, (GCompareFunc)(strcmp));*/
  filelist = g_list_concat(filelist, g_list_copy(root));
  return root;
}

void save_config(void)
{
  gchar **dirname, **fnames;
  gint length, x;
  GList *cur;

  length = g_list_length(dirnames);
  dirname = (gchar **)g_malloc(sizeof(gchar *) * length);
  for (x = 1; x < length; x++) {
    cur = g_list_nth(dirnames, x);
    dirname[x - 1] = strdup((gchar *)cur->data);
  }
  gnome_config_set_vector(
    "/gBackGround_applet/Look_For/Directories", length - 1, (gpointer)dirname);
  for (x = 0; x < length - 1; x++) g_free(dirname[x]);
  g_free(dirname);
  length = g_list_length(indfiles);
  fnames = (gchar **)g_malloc(sizeof(gchar *) * (length + 1));
  for (x = 0; x < length; x++) {
    cur = g_list_nth(indfiles, x);
    fnames[x] = strdup((gchar *)((struct entry *)cur->data)->path);
  }
  gnome_config_set_vector(
    "/gBackGround_applet/Look_For/Files", length, (gpointer)fnames);
  for (x = 0; x < length; x++) g_free(fnames[x]);
  g_free(fnames);
  gnome_config_set_string("gBackGround_applet/Look_For/Current_File", curfile);
  gnome_config_set_int("/gBackGround_applet/Mode/Start_Mode",
                        startmode);
  gnome_config_set_int("/gBackGround_applet/Mode/Change_Mode", changemode);
  gnome_config_set_int("/gBackGround_applet/Misc/Interval", interval/1000);
  gnome_config_set_int("/gBackGround_applet/Mode/Tiled", tile);
  gnome_config_set_int("/gBackGround_applet/Mode/Scaled", scaleit);
  gnome_config_set_int("/gBackGround_applet/Mode/Centered", center);
  gnome_config_set_int("/gBackGround_applet/Misc/Use_real_mime", userealmime);
  gnome_config_set_int( "/gBackGround_applet/Mode/movemode", movemode);
  gnome_config_set_float( "/gBackGround_applet/Misc/speed", speed);
  gnome_config_set_float( "/gBackGround_applet/Misc/radius", radius);
  gnome_config_set_float( "/gBackGround_applet/Misc/storethumbs", storethumbs);
  gnome_config_sync();
}

gint save_myself(GnomeClient *c, gint p, GnomeSaveStyle ss, int s,
                 GnomeInteractStyle is, gint f, gpointer d)
{
  if (GNOME_CLIENT_CONNECTED(c))
    gnome_config_push_prefix(gnome_client_get_config_prefix(c));
  save_config();
  if (GNOME_CLIENT_CONNECTED(c))
    gnome_config_pop_prefix();
  return TRUE;
}

void die(GtkWidget *w, gpointer d)
{
  gtk_exit(0);
}
