
/*  gBackGround changes your root window background.
    Copyright (C) 1999  Govind Salinas

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef GBACKGROUND_H
  #include "gBackGround.h"
#endif

Pixmap pixmap, pmap;
gint w, h, set = 0;
GdkVisual *vis;
GC xgc;
Display *dis = NULL;

/*static Window get_desktop_window(Window the_window)
{
  Window win, root, *children, parent;
  Atom prop, type, prop2;
  int format;
  unsigned long length, after;
  unsigned char *data;
  unsigned int nchildren;

  prop = XInternAtom(GDK_DISPLAY(), "_XROOTPMAP_ID", True);
  prop2 = XInternAtom(GDK_DISPLAY(), "_XROOTCOLOR_PIXEL", True);
  
  if (prop == None && prop2 == None) return None;
  for (win = GDK_WINDOW_XWINDOW(GTK_WIDGET(applet)->window); win;
       win = parent) {
    if (XQueryTree(GDK_DISPLAY(), win, &root, &parent, &children, &nchildren) ==
        False) win = None;
    if (nchildren) XFree(children);
    if (prop != None)
      XGetWindowProperty(GDK_DISPLAY(), win, prop, 0L, 1L, False,
                         AnyPropertyType, &type, &format, &length, &after,
                         &data);
    else if (prop2 != None)
      XGetWindowProperty(GDK_DISPLAY(), win, prop2, 0L, 1L, False,
                         AnyPropertyType, &type, &format, &length, &after,
                         &data);
    else continue;
    if (type != None) return win;
  }
  return None;
}*/

void displayfiles(gchar *nameofentry)
{
  GtkWidget *button, *vbox, *box = NULL, *pix;
  GtkTooltips *tooltip;
  int curnum, length, val, h, w, done = 0;
  GList *curdir, *curfile;
  GdkImlibImage *prepix = NULL, *postpix = NULL;
  gfloat scale;

  if (scrollwindow) gtk_widget_destroy(GTK_WIDGET(scrollwindow));
  scrollwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrollwindow),
                                 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_set_usize(GTK_WIDGET(scrollwindow), 275, 350);
  vbox = gtk_vbox_new(TRUE, 0);
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrollwindow),
                                        vbox);
  gtk_container_add(GTK_CONTAINER(frame), scrollwindow);
  if (!strcmp(nameofentry, "(Indavidual Files.)"))
    curdir = indfiles;
  else {
    if ((val = g_list_index(dirnames, (gpointer)nameofentry)) < 0) return;
    curdir = g_list_nth(dirlist, val - 1);
    curdir = curdir->data;
  }
  length = g_list_length(curdir);
  for (curnum = 0; curnum < length; curnum++) {
    curfile = g_list_nth(curdir, curnum);
    if (!curfile) {
      gtk_widget_show_all(scrollwindow);
      return;
    }
    if (((struct entry *)curfile->data)->thumb == NULL || !storethumbs) {
      prepix = gdk_imlib_load_image((gchar *)((struct entry *)curfile->data)->path);
      done = 1;
    }
    else prepix = postpix = ((struct entry *)curfile->data)->thumb;
    if (prepix) {
      if (curnum%5 == 0) {
        box = gtk_hbox_new(TRUE, 0);
        gtk_box_pack_start(GTK_BOX(vbox), box, FALSE, FALSE, 0);
      }
      h = prepix->rgb_height;
      w = prepix->rgb_width;
      if (h > w) scale = ((float)48/h);
      else scale = ((float)48/w);
      h = scale*h;
      w = scale*w;
      if (done) {
        postpix = gdk_imlib_clone_scaled_image(prepix, w, h);
        gdk_imlib_kill_image(prepix);
        ((struct entry *)curfile->data)->thumb = postpix;
      }
      done = 0;
      pix = gnome_pixmap_new_from_imlib_at_size(postpix, w, h);
      tooltip = gtk_tooltips_new();
      button = gtk_button_new();
      gtk_signal_connect(GTK_OBJECT(button), "clicked",
                         GTK_SIGNAL_FUNC(choosebg),
                         ((struct entry *)curfile->data)->path);
      gtk_widget_set_usize(button, 50, 50);
      gtk_tooltips_set_tip(tooltip, button,
                           (gchar *)((struct entry *)curfile->data)->path, NULL);
      gtk_container_add(GTK_CONTAINER(button),
                        GTK_WIDGET(pix));
      gtk_box_pack_start(GTK_BOX(box), button, TRUE, FALSE, 0);
    }
    gtk_progress_bar_update(GTK_PROGRESS_BAR(pbar),
                           ((gdouble)curnum + 1)/length);
    gtk_progress_set_format_string(GTK_PROGRESS(pbar),
                                  "%p%% of thumbnails loaded");
    gtk_progress_set_show_text(GTK_PROGRESS(pbar), TRUE);
    while(gtk_events_pending()) gtk_main_iteration();
  }
  gtk_widget_show_all(scrollwindow);
}

gint draw_background(gchar *name)
{
  gint x, y, d, h2, w2;
  GdkWindow *rootwin;
  GdkImlibImage *pic2;
  gfloat scale;
  Pixmap pix;
  GdkPixmap *gpix, *curpic;
  GdkGC *gc;
  XGCValues gcv;
  /*Window win;*/
 
  if (set) {
    XFreePixmap(dis, pixmap);
    XFreePixmap(dis, pmap);
    XFreeGC(dis, xgc);
  }
  set = 1;
  dis = GDK_DISPLAY();
  rootwin = GDK_ROOT_PARENT();
  gdk_window_get_geometry(rootwin, &x, &y, &w, &h, &d);
  gc = gdk_gc_new(rootwin);
  curpic = gdk_pixmap_new(rootwin, w, h, -1);
  if (!(pic2 = gdk_imlib_load_image(name))) return 0;
  h2 = pic2->rgb_height;
  w2 = pic2->rgb_width;
  if (h < h2) {
    scale = ((float)h/h2);
    h2 = scale * h2;
    w2 = scale * w2;
  }
  if (w < w2) {
    scale = ((float)w/w2);
    h2 = scale * h2;
    w2 = scale * w2;
  }
  if (tile || (!center && !scaleit))
    for (x = 0; x < h; x += h2) for (y = 0; y < w; y += w2)
      gdk_imlib_paste_image(pic2, curpic, y, x, w2, h2);
  if (center) {
    x = (h - h2)/2;
    y = (w - w2)/2;
    gdk_imlib_paste_image(pic2, curpic, y, x, w2, h2);
  }
  if (scaleit) {
    if (h2 > w2) {
      scale = ((float)h/h2);
      h2 = scale * h2;
      w2 = scale * w2;
    }
    else {
      scale = ((float)w/w2);
      h2 = scale * h2;
      w2 = scale * w2;
    }
    x = (h - h2)/2;
    y = (w - w2)/2;
    gdk_imlib_paste_image(pic2, curpic, y, x, w2, h2);
  }
  vis = gdk_imlib_get_visual();
  XSetCloseDownMode(dis, RetainPermanent);
  pix = XCreatePixmap(dis, DefaultRootWindow(dis), w, h,
                      vis->depth);
  pmap = XCreatePixmap(dis, DefaultRootWindow(dis), w, h,
                      vis->depth);
  gpix = gdk_pixmap_foreign_new(pix);
  gdk_window_copy_area(gpix, gc, 0, 0, curpic, 0, 0, w, h);
  pixmap = (Pixmap)((GdkWindowPrivate *)gpix)->xwindow;
  gdk_property_change (rootwin, gdk_atom_intern("ESETROOT_PMAP_ID", FALSE),
                       XA_PIXMAP, 32, PropModeReplace, (guchar *) &pixmap, 1);
  gdk_property_change (rootwin, gdk_atom_intern("_XROOTPMAP_ID", FALSE),
                       XA_PIXMAP, 32, PropModeReplace, (guchar *) &pixmap, 1);
  gdk_gc_unref(gc);
  /*win = get_desktop_window(GDK_WINDOW_XWINDOW(GTK_WIDGET(applet)->window));*/
  XSetWindowBackgroundPixmap(dis, GDK_ROOT_WINDOW(), pixmap);
  XFlush(dis);
  XClearWindow(dis, GDK_ROOT_WINDOW());
  /*gdk_window_set_back_pixmap(rootwin, curpic, 0);
  gdk_flush();
  gdk_window_clear(rootwin);*/
  gdk_imlib_kill_image(pic2);
  gnome_config_set_string("gBackGround_applet/Look_For/Current_File", name);
  gnome_config_sync();
  gdk_imlib_free_pixmap(curpic);
  xgc = XCreateGC(dis, pmap, 0, &gcv);
  XSetTile(dis, xgc, pixmap);
  XSetFillStyle(dis, xgc, FillTiled);
  return 1;
}

gint movebg(gpointer data)
{
  static float x = 0, y = 0;
  
  if (movemode != 1) return FALSE;
/*  pmap = XCreatePixmap(dis, DefaultRootWindow(dis), w, h, vis->depth);
  XCopyArea(dis, pixmap, pmap, xgc, 0, 0, w, h, (int)(radius*sin(2*y)),
            (int)(radius*cos(x+1)));*/

  XSetTSOrigin(dis, xgc, (int)(radius*sin(2*y)), (int)(radius*cos(x+1)));
  XFillRectangle(dis, pmap, xgc, 0, 0, w, h);
  XSetWindowBackgroundPixmap(dis, GDK_ROOT_WINDOW(), pmap);
  /*XFlush(GDK_DISPLAY());*/
  XClearWindow(dis, GDK_ROOT_WINDOW());
  XSync(dis, False);
  x = x + (1/radius)*speed;
  y = y + (1/radius)*speed;
  /*XFreePixmap(dis, pmap);*/
  while (gtk_events_pending()) gtk_main_iteration();
  return TRUE;
}
