#ifndef GBACKGROUND_H
  #include "gBackGround.h"
#endif
#include "pick.xpm"
#include "random.xpm"

GList *filelist = NULL;
GList *indfiles = NULL;
GList *dirnames = NULL;
GList *dirlist = NULL;
GList *piclist = NULL;
GtkWidget *window = NULL, *scrollwindow, *applet;
GtkWidget *combo, *pbar, *frame, *hbox, *vbox;
gchar *lastfile, *curfile;
gint dirnum, filesnum, interval, changemode, startmode;
gint tile = 0, center = 0, scaleit = 1;

int main(int argc, char **argv)
{
  GtkWidget *mainbox, *frame1, *frame2;
  GtkTooltips *tooltip;
  GtkWidget *randompix, *choosepix;
  GtkWidget *button1, *button2;
  PanelOrientType orient;
  GnomeClient *client;
  
  /* Initializing Apllet */
  applet_widget_init(PACKAGE, VERSION, argc, argv, NULL, 0, NULL);
  applet = applet_widget_new(PACKAGE);
  client = gnome_master_client();
  gtk_widget_realize(applet);

  /* Initializing Imlib */
  gdk_imlib_init();
  gtk_widget_push_visual(gdk_imlib_get_visual());
  gtk_widget_push_colormap(gdk_imlib_get_colormap());

  mainbox = gtk_vbox_new(FALSE, 0);
  hbox = gtk_hbox_new(FALSE, 0);
  vbox = gtk_vbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(mainbox), hbox, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(mainbox), vbox, FALSE, FALSE, 0);

  /* Making and initializing my first button */
  button1 = gtk_button_new();
  randompix = gnome_pixmap_new_from_xpm_d(random_xpm);
  gtk_container_add(GTK_CONTAINER(button1), randompix);
  gtk_signal_connect(GTK_OBJECT(button1), "clicked",
                     GTK_SIGNAL_FUNC(button1_callback), NULL);
  gtk_widget_set_usize(button1, 19, 19);
  gtk_widget_show(randompix);
  gtk_widget_show(button1);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip(tooltip, button1, "Random Background.", NULL);
  frame1 = gtk_frame_new(NULL);
  gtk_container_set_border_width(GTK_CONTAINER(frame1), 1);
  gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame1), button1);
  button1 = gtk_button_new();
  randompix = gnome_pixmap_new_from_xpm_d(random_xpm);
  gtk_container_add(GTK_CONTAINER(button1), randompix);
  gtk_signal_connect(GTK_OBJECT(button1), "clicked",
                     GTK_SIGNAL_FUNC(button1_callback), NULL);
  gtk_widget_set_usize(button1, 19, 19);
  gtk_widget_show(randompix);
  gtk_widget_show(button1);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip(tooltip, button1, "Random Background.", NULL);
  frame2 = gtk_frame_new(NULL);
  gtk_container_set_border_width(GTK_CONTAINER(frame2), 1);
  gtk_box_pack_start(GTK_BOX(vbox), frame2, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame2), button1);
  gtk_widget_show(frame1);
  gtk_widget_show(frame2);

  /* Making and initializing my second button */
  button2 = gtk_button_new();
  choosepix = gnome_pixmap_new_from_xpm_d(pick_xpm);
  gtk_container_add(GTK_CONTAINER(button2), choosepix);
  gtk_signal_connect(GTK_OBJECT(button2), "clicked",
                     GTK_SIGNAL_FUNC(button2_callback), NULL);
  gtk_widget_set_usize(button2, 19, 19);
  gtk_widget_show(choosepix);
  gtk_widget_show(button2);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip(tooltip, button2, "Pick Background.", NULL);
  frame1 = gtk_frame_new(NULL);
  gtk_container_set_border_width(GTK_CONTAINER(frame1), 1);
  gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame1), button2);
  button2 = gtk_button_new();
  choosepix = gnome_pixmap_new_from_xpm_d(pick_xpm);
  gtk_container_add(GTK_CONTAINER(button2), choosepix);
  gtk_signal_connect(GTK_OBJECT(button2), "clicked",
                     GTK_SIGNAL_FUNC(button2_callback), NULL);
  gtk_widget_set_usize(button2, 19, 19);
  gtk_widget_show(choosepix);
  gtk_widget_show(button2);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip(tooltip, button2, "Pick Background.", NULL);
  frame2 = gtk_frame_new(NULL);
  gtk_container_set_border_width(GTK_CONTAINER(frame2), 1);
  gtk_box_pack_start(GTK_BOX(vbox), frame2, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame2), button2);
  gtk_widget_show(frame1);
  gtk_widget_show(frame2);

  /* Check orientation so we know to do a vertical or a horizontal applet */
  orient = applet_widget_get_panel_orient(APPLET_WIDGET(applet));
  /* Setting up the boxes to put my buttons in */
  if (orient == ORIENT_UP || orient == ORIENT_DOWN) {
    gtk_widget_show(vbox);
    gtk_widget_hide(hbox);
  }
  else {
    gtk_widget_show(hbox);
    gtk_widget_hide(vbox);
  }
  gtk_container_set_border_width(GTK_CONTAINER(mainbox), 0);
    
  /* Show the box and add it to the applet */
  applet_widget_add(APPLET_WIDGET(applet), mainbox);
  gtk_widget_show(mainbox);

  /* Add stuff to the properties menu */
  applet_widget_register_stock_callback(APPLET_WIDGET(applet), "Properties",
                                        GNOME_STOCK_MENU_PROP,
                                        _("Properties..."),
                                        properties_callback, NULL);
  applet_widget_register_stock_callback(APPLET_WIDGET(applet), "About",
                                        GNOME_STOCK_MENU_ABOUT, _("About..."),
                                        about_callback, NULL);
  applet_widget_register_callback(APPLET_WIDGET(applet), "StopChange",
                                  _("Stop Changing Background"),
                                   menu_item_callback, (gpointer)0);
  applet_widget_register_callback(APPLET_WIDGET(applet), "StartLinear",
                                  _("Sart Changing Background (in order)"),
                                   menu_item_callback, (gpointer)1);
  applet_widget_register_callback(APPLET_WIDGET(applet), "StartRandom",
                                  _("Sart Changing Background (randomly)"),
                                   menu_item_callback, (gpointer)2);
  applet_widget_register_callback(APPLET_WIDGET(applet), "Tile",
                                  _("Tile Backgounds"),
                                   menu_item_callback, (gpointer)3);
  applet_widget_register_callback(APPLET_WIDGET(applet), "Scale",
                                  _("Scale Backgrounds"),
                                   menu_item_callback, (gpointer)4);
  applet_widget_register_callback(APPLET_WIDGET(applet), "Center",
                                  _("Center Backgrounds"),
                                   menu_item_callback, (gpointer)5);
  applet_widget_register_callback(APPLET_WIDGET(applet), "MovingBackground",
                                  _("Moving Background"),
                                   menu_item_callback, (gpointer)6);
  applet_widget_register_callback(APPLET_WIDGET(applet), "StopMovingBackground",
                                  _("Stop Moving Background"),
                                   menu_item_callback, (gpointer)7);

  /* Start everything going */
  gtk_widget_show(applet);
  init();
  gtk_signal_connect(GTK_OBJECT(client), "save_yourself",
                     GTK_SIGNAL_FUNC(save_myself), (gpointer)argv[0]);
  gtk_signal_connect(GTK_OBJECT(client), "die", GTK_SIGNAL_FUNC(die), NULL);
  gtk_signal_connect(GTK_OBJECT(applet), "change_orient",
                     GTK_SIGNAL_FUNC(change_orient), NULL);
  gtk_timeout_add(300000, (GtkFunction)save_callback, NULL);
  applet_widget_gtk_main();

  /* Exit */
  return 0;
}
